package ProjectElectricLocomotive.src.CollectionGenericObjects;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class StorageCollection<T extends Object> {

    private final Map<String, ICollectionGenericObjects<T>> storage;


    public List<String> getKeys() {
        return new ArrayList<>(storage.keySet());
    }

    public StorageCollection() {
        storage = new HashMap<>();
    }

    public void addCollection(String name, CollectionType collectionType) {
        if (name == null || storage.containsKey(name)) return;
        if (collectionType == CollectionType.Massive) {
            storage.put(name, new MassiveGenericObjects<>());
        } else if (collectionType == CollectionType.List) {
            storage.put(name, new ListGenericObjects<>());
        }
    }

    public void delCollection(String name) {
        storage.remove(name);
    }

    public ICollectionGenericObjects<T> get(String name) {
        return storage.get(name);
    }
}
